BMAP bubblemap,<bubble.bmp>;
BMAP blood_map,<blood.bmp>;
BMAP firemap1,<light.bmp>;
BMAP firemap2,<green1.bmp>;
BMAP firemap3,<blue2.bmp>;
BMAP firemap4,<blue1.bmp>;
BMAP darkmap,<dark.bmp>;

SOUND squish,<diesplat.wav>;
//SOUND splat,<gibsplat.wav>;


function glasshit()
{
	IF (EVENT_TYPE == EVENT_SCAN){IF (indicator != _EXPLODE) && (indicator != _GUNFIRE) {END;}}
	
//	PLAY_SOUND	glassb,45;
	MY.ALPHA += damage*.5;
	MY._HEALTH -= damage;
	IF (MY._HEALTH <= 0)
	{
//		PLAY_SOUND glassb,100;
		glass_gib(10);
		REMOVE(ME);
	}
}

// Desc: look_even (look ahead)
ACTION blick_gerade
{
	head_angle.TILT = 0;
}

ON_TAB blick_gerade;         // look ahead keys


var flare_var = 0;

action light_flare
{
	my.flare = on;
	my.red = your.red;
	my.green = your.green;
	my.blue = your.blue;
	my.light = on;
	my.lightrange = 0;
	my.passable = on;
	my.oriented = on;  // will now be facing according to its pan, tilt and roll to get a better facing effect using me_on_player()
	my.near = on;  // reduce clipping
	while (1)
	{
		me_on_player();
		flare_var = vec_dist(player.x, my.x);
		flare_var = min(flare_var,2000);
		my.scale_x = (flare_var / 900 + 0.5);
		my.scale_y = my.scale_x;  // small optimization (scale_x = scale_y always)
		if (flare_var < 30)
		{
			my.invisible = on;
		}
		else
		{
			my.invisible = off;
		}
		wait(1);
	}
}

function me_on_player() {
	// keep me facing the player
	vec_set(temp,player.x);
	vec_sub(temp,my.x);
	vec_to_angle(my.pan,temp); 
}


ACTION window
{
	MY.TRANSPARENT = ON;
	MY.ALPHA = 50;
	MY.ORIENTED = ON;
	MY._HEALTH = 100;
	MY.EVENT = glasshit;
	MY.ENABLE_SHOOT = ON;
	MY.ENABLE_SCAN = ON;
	MY.PUSH = 10;
}

function	glass_gib(numberOfParts)
{
	temp = 0;
	while(temp < numberOfParts)
	{
		create(<glass.mdl>, MY.POS, _gib_action);
		temp += 1;
	}

}




ACTION actor_gibs
{
	MY.PASSABLE = ON;
	_actor_gib();
	REMOVE(ME);
}

var gibparts,11;
var gibvar;
var gibmax,20;
var bloodlevel,10;
var gibnow,0;
var splatlevel,3;

function	_actor_gib()
{
	create(<gib03.mdl>, MY.POS, _body_gib_action);
  	create(<gib05.mdl>, MY.POS, _body_gib_action);
	gibvar = gibparts;
	WHILE (gibvar >= 2)
	{
		create(<gib02.mdl>, MY.POS, _body_gib_action);
		create(<gib02.mdl>, MY.POS, _body_gib_action);
		create(<gib04.mdl>, MY.POS, _body_gib_action);
		gibvar -= 3;
	}
}

function get_gem()
{
	if(EVENT_TYPE == EVENT_SCAN && indicator != _HANDLE) { return; }
	if(EVENT_TYPE == EVENT_PUSH && YOU != player) { return; }

	WHILE (MY.ALPHA >= 0)
	{
		MY.ALPHA -= .2 * TIME;
		WAIT(2);
	}
	REMOVE(ME);
}

ACTION gem
{
	IF (MY.SKILL1 == 0) { MY.SKILL1 = 100; }
	MY.ALPHA		=	MY.SKILL1;

	MY.EVENT = get_gem;
	item_pickup();
	WHILE(1)
	{
		MY.PAN += 1;
		WAIT(1);
	}

}

var light_var;

ACTION light
{
	IF (MY.FLAG1 == ON) // FIRE
	{
		if (my.skill1 == 0) { my.skill1 = 225; }
		if (my.skill2 == 0) { my.skill2 = 140; }
		if (my.skill3 == 0) { my.skill3 = 0; } //red light
		if (my.skill4 == 0) { my.skill4 = 70; }
		if (my.skill5 == 0) { my.skill5 = 100; }
		my.red = my.skill1;
		my.green = my.skill2;
		my.blue = my.skill3;

		while (1)
		{
			my.lightrange = my.skill4 + random(my.skill5);
			my.red += random(my.skill6)-(my.skill6 / 2);
			my.green += random(my.skill7)-(my.skill7 / 2);
			my.blue += random(my.skill8)-(my.skill8 / 2);
			wait(1);
		}
	}

	IF (MY.FLAG2 == ON) // FLICKERING LAMP
	{
		if (my.skill1 == 0) { my.skill1 = 155; }
		if (my.skill2 == 0) { my.skill2 = 55; }
		if (my.skill3 == 0) { my.skill3 = 55; } //red light
		while (1)
		{
		// light on
			my.red = my.skill1;
			my.blue = my.skill2;
			my.green = my.skill3;
			my.ambient = 100;
			my.lightrange = 150;
			light_var = random(8);
			wait(light_var);
			
		// light off
			my.ambient = 0;
			my.lightrange = 0;
			light_var = random(16);
			wait(light_var);
			
			wait(1);
		}
	}
}

ACTION alpha_glow
{
	IF (MY.SKILL1 == 100) { MY.SKILL1 = 25; } //MINIMUM ALPHA TRANSPARANCY
	IF (MY.SKILL2 == 0) { MY.SKILL2 = 100; } //MAXIMUM ALPHA TRANSPARANCY
	IF (MY.SKILL3 == 0) { MY.SKILL3 = 1; } //GLOW SPEED
	MY.TRANSPARENT == ON;
	MY.ALPHA = MY.SKILL1;
	WHILE(1)
	{
		WHILE(MY.ALPHA <= MY.SKILL2)
		{
			MY.ALPHA += MY.SKILL3 * TIME;
			WAIT(1);
		}
		WHILE(MY.ALPHA >= MY.SKILL1)
		{
			MY.ALPHA -= MY.SKILL3 * TIME;
			WAIT(1);
		}
	}
}

function fade_func()
{
	my.alpha -= my.skill_x * time;
	if(my.alpha < 0) { my.lifespan = 0; }
}

function vec_blood(&vec)
{
	vec[0] = random(5)-2.5;
	vec[1] = random(5)-2.5;
	vec[2] = random(5)-2.5;
}

function particle_blood
{
	vec_blood(temp);
	vec_set(my.vel_x,temp);
	my.move = on;
	my.streak = on;
	my.flare = on;
	my.size = 10;
	my.bright = on;
	my.alpha = 65;
	my.bmap = blood_map;
	my.lifespan = 35;
	my.skill_x = 0.01;
	my.gravity = 2;
	my.function = fade_func;
}

// Desc: Init and animate a gib-bit
//
// Mod Date: 6/29/00 Doug Poston
//				Added rotation and alpha-fading
// Mod Date: 8/31/00 DCP
//				Scale absdist vector by movement_scale
//				Scale the gibbits down by the actor_scale
function _body_gib_action()
{
// scall the bits down by the actor_scale amount
if (gibnow >= gibmax) { ent_remove(my); end; }
gibnow += 1;
vec_scale(my.SCALE_x,actor_scale);
my.enable_block = on;
	
// Init gib bit
my._speed_x = 15 * (RANDOM(10) - 5); // -125 -> +125
my._speed_y = 15 * (RANDOM(10) - 5); // -125 -> +125
my._speed_z = RANDOM(35) + 15; // 15 -> 50
my._aspeed_pan = RANDOM(35) + 5; // 35 -> 70
my._aspeed_tilt = RANDOM(35) + 5; // 35 -> 70
my._aspeed_roll = RANDOM(35) + 5; // 35 -> 70
my._force = 0;
my.roll = RANDOM(180); // start with a random orientation
my.pan = RANDOM(180);
my._force = -2;
my.push = -1; // allow user/enemys to push thru
	
abspeed[0] = 5 * my._speed_x;
abspeed[1] = 5 * my._speed_y;
abspeed[2] = my._speed_z * time * 5;
move(me,nullskill,abspeed);        // move them away from the gib point so we don't get floating blood splats

// Animate gib-bit
my.skill9 = 50;
while(my.skill9 > -75)
{
abspeed[0] = my._speed_x * time;
abspeed[1] = my._speed_y * time;
abspeed[2] = my._speed_z * time;
my.pan += my._aspeed_pan * time;
my.tilt += my._aspeed_tilt * time;
my.roll += my._aspeed_roll * time;
vec_scale(absdist,movement_scale); // scale absolute distance by movement_scale
move(me,nullskill,abspeed);
effect(particle_blood,bloodlevel * time,my.x,nullskill);
if(bounce.z)
{
create(<blooda.bmp>,my.x,blood_spat);
my._speed_z = -(my._speed_z/2);
if(my._speed_z < 0.25)
{
my._speed_x = 0;
my._speed_y = 0;
my._speed_z = 0;
my._aspeed_pan = 0;
my._aspeed_tilt = 0;
my._aspeed_roll = 0;
}
gibvar = bloodlevel * splatlevel;
effect(particle_blood,gibvar * time,my.x,nullskill);
// my.skill9 -= 100;
}
my._speed_z -= 2;
my.skill9 -= 1;
wait(1);
gibnow -= 1;
ent_remove(my);
return;
}
my.passable = on;
// Fade out
my.transparent = on;
my.alpha = 100;
while(1)
{
my.alpha -= 5*time;
if(my.alpha <=0)
{
// remove
gibnow -= 1;
ent_remove(my);
return;
}
wait(1);
}
}

function testgibs()
{
	if((EVENT_TYPE == EVENT_SCAN) && (indicator == _HANDLE))
	{
		PLAY_SOUND squish,100;
		BRANCH actor_gibs;
		effect(particle_blood,100,my.x,nullskill);
		REMOVE(ME);
	}

}

ACTION testgib
{
	MY.EVENT = testgibs;
	MY.ENABLE_SHOOT = ON;
	MY.ENABLE_SCAN = ON;
	MY.PUSH = 10;
}

function blood_spat()
{
scan_sector.pan = 360;
scan_sector.roll = 360;
scan_sector.tilt = 360;
my_angle.pan = my.pan;
my_angle.tilt = my.tilt;
scan(my.x,my_angle,scan_sector);

if(bullet_hole_counter <= kmaxbullethole && you != player)
{
bullet_hole_counter += 1; // inc bullet hole counter
my.transparent = on;
my.passable = on;
my.oriented = on;
vec_to_angle(my.pan,normal); // rotate to target normal
waitt(160); // time blood stays before vanishing, wait a fixed amount of time with waitt(160), rather than 160 frames with wait(160)
while(my.alpha > 0) // fade out
	{
my.alpha -= time;
waitt(1);
}
bullet_hole_counter -= 1; // decrease bullet hole counter
ent_remove(my);
}
else
{
ent_remove(my);
}
}

function sheild()
{
	IF (EVENT_TYPE != EVENT_PUSH || YOU != PLAYER) { END; }
	MORPH <guard.mdl>,ME;
	MY.SKILL1 = 100;
	MY.PASSABLE = OFF;
	MY.TRANSPARENT = ON;
	MY.EVENT = NULL;
	MY.SCALE_Z = 1.02;
	MY.SCALE_X = 1.02;
	MY.SCALE_Y = 1;
	WHILE (1)
	{
		MY.X = PLAYER.X;
		MY.Y = PLAYER.Y;
		MY.Z = PLAYER.Z;
		MY._MOVEMODE = PLAYER._MOVEMODE;
		MY.TILT = PLAYER.TILT;
		MY.PAN = PLAYER.PAN;
		MY.ROLL = PLAYER.ROLL;
		MY.ALPHA = MY.SKILL1 * 0.5;
		MY.FRAME = PLAYER.FRAME - 1;
		WAIT(1);
	}
}

ACTION sheildpac
{
	MY.EVENT = sheild;
	item_pickup();

}

bmap fire_map1 = <light.bmp>;
var firevar2,1;

function vec_fire(&vec)
{
vec[0] = random(30) - 15;
vec[1] = random(30) - 15;
vec[2] = random(10) - (abs(my.vel_x) + abs(my.vel_y)) * 0.3 + random(5);
}

function fire_func()
{
my.vel_x = my.vel_x * 0.5;
my.vel_y = my.vel_y * 0.5;
my.alpha -= time * 2;
if(my.alpha < 0) { my.lifespan = 0; }
if (firevar2 == 1) { my.bmap = firemap1; }
if (firevar2 == 2) { my.bmap = firemap2; }
if (firevar2 == 3) { my.bmap = firemap3; }
if (firevar2 == 4) { my.bmap = firemap4; }
}

function firechange()
{
firevar2 += 1;
if (firevar2 == 5) { firevar2 -= 4; }
wait(1);
}

on_t firechange;

function particle_fire()
{
vec_fire(temp);
vec_set(my.vel_x,temp);
my.lifespan = 15;
my.flare = on;	//flare transparency
my.bright = on;	//glowing effect
my.move = on;	//move according to vel_x, vel_y, and vel_z
my.streak = on;	//new streak effect
if (firevar2 == 1) { my.bmap = firemap1; }
if (firevar2 == 2) { my.bmap = firemap2; }
if (firevar2 == 3) { my.bmap = firemap3; }
if (firevar2 == 4) { my.bmap = firemap4; }
my.alpha = 20;
my.size = 10;
my.function = fire_func;	//no mid-life mods yet!
}

var firevar;

action fire1
{
if (my.skill1 == 0) { my.skill1 = 8; }
while (1)
{
firevar = my.skill1;                            // sets the # of particles to be released.
effect(particle_fire,firevar * time,my.x,nullvector);    // emit the particles from my.x using the new effect command (A5)
wait(1);
}
}

ACTION starsphere
{
	WHILE(1)
	{
		MY.PAN += 0.5 * TIME;
		MY.TILT += 0.5 * TIME;
		WAIT(1);
	}
}


function firechange()
{
	firevar2 += 1;
	IF (firevar2 == 5) { firevar2 -= 4; }
	WAIT(1);
}

ON_T firechange;

bmap smoke_map2,<rauch.bmp>;

function vec_smoke(&vec)
{
vec[0] = random(1) - 0.5;
vec[1] = random(1) - 0.5;
vec[2] = random(1) + 1;
}

function smoke_func()
{
if(my.size < 800) { my.size += time * 0.1; }
my.alpha -= 2.1 * time;
if(my.alpha < 0) { my.lifespan = 0; }
my.vel_x = my.vel_x / 1.2;
my.vel_y = my.vel_y / 1.2;
}
function particle_smoke()
{
vec_smoke(temp);
vec_set(my.vel_x,temp);
my.size = random(5)+5; // 5 to 10 in size
my.bmap = smoke_map2;
my.flare = on;
my.lifespan = 100;
my.alpha = 50;
my.move = on;
my.function = smoke_func;
}

action smoker
{
	while(1)
	{
		effect(particle_smoke,5 * time,my.x,nullvector);
		wait(1);
	}
}

bmap fountain_map = <sparkle.bmp>;
 
function vec_fountain(&vec)
{
vec[0] = random(6) - 3;
vec[1] = random(6) - 3;
vec[2] = random(10) + 20;
}

function particle_alpha_fade()
{
my.alpha -= time * 2;  // stay with framerate
if(my.alpha < 0) { my.lifespan = 0;}
}

function particle_fountain()
{
vec_fountain(temp);
vec_set(my.vel_x,temp); //set the velocity
my.lifespan = 50;
my.flare = on;	//flare transparency
my.bright = on;	//glowing effect
my.move = on;	//move according to vel_x, vel_y, and vel_z
my.streak = on;	//new streak effect
my.bmap = fountain_map;
my.gravity = 3;
my.alpha = 50;
my.size = 10;
my.function = particle_alpha_fade;	//fade out near end of life
}

action fountain
{
	while(1)
	{
		effect(particle_fountain,7 * time,my.x,nullvector);
		wait(1);
	}
}

BMAP explo_map2,<expl.bmp>;

function vec_explode(&vec)
{
     vec[0] = random(60) - 30;
     vec[1] = random(60) - 30;
     vec[2] = random(10) + 20;
}

function explosion_func()
{
	if(my.lifespan > 40) { my.alpha += 1 * TIME; }
	if(my.lifespan <= 40) { my.alpha -= 10 * TIME; }
	if(my.alpha <= 0) {my.lifespan = 0;}
}

function particle_explo()
{
        vec_explode(temp);
	  vec_set(my.vel_x,temp);
        my.flare = on;
        my.bright = on;
        my.move = on;
        my.beam = on;
        my.bmap = explo_map2;
        my.gravity = 6;
        my.alpha = 30;
        my.size = random(5) + 5;          // 50-100
        my.lifespan = 50;
        my.function = explosion_func;
}

var exp,0;

function start_exp_test()
{
	exp = 1;
}

ACTION explode_test
{
	my.invisible = on;
	WHILE(1)
	{
		WHILE(exp == 0)
		{
			WAIT(1);
		}
		effect(particle_explo,50,my.x,nullvector);
		create(<expl2+16.pcx>,my.x,explode1);
		exp = 0;
	}
}

ON_E start_exp_test();

action explode1
{
my.facing = on; // face the camera
my.near = on;
my.flare = on;
my.passable = on; // don't push the player through walls
my.frame = 1;
my._dieframes = 16;
wait(1);

play_entsound(my,explo_wham,1000);
my.red = 210;
my.green = 100;
my.blue = 100;
my.ambient = 100;
my.lightrange = 110;

// use the new sprite animation
while(my.frame < my._dieframes)
{
wait(1);
my.lightrange += 15;
my.red += 20 * time; // fade to red  // stay with framerate
my.blue -= 20 * time;  // stay with framerate
my.frame += time;  // stay with framerate
}
wait(1);
ent_remove(my);
}